<template>
  <div class="fr-container fr-p-5w">
    <TheHeader
      :title="title"
      :back-link="backLink"
    />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main
          ref="formContainer"
          class="main-container fr-p-5w"
        >
          <AtomAlert
            v-if="fetchError"
            :alert-type="AlertType.Error"
            :message="fetchError"
          />

          <AtomLoader
            v-if="pending"
            class="fr-mx-auto"
          />
          <HelpRequestForm
            v-else-if="
              helpRequest &&
              followUpTypes &&
              organismesPrescripteurs &&
              organismesInstructeurs
            "
            :is-submitting="isSubmitting"
            :follow-up-types="followUpTypes"
            :help-request="helpRequest"
            :beneficiary-id="beneficiaryId"
            :organismes-prescripteurs="organismesPrescripteurs"
            :organismes-instructeurs="organismesInstructeurs"
            @save-help-request="onUpdateHelpRequest"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { beneficiaryName } from '~/utils/beneficiary'
  import { BeneficiaryTab } from '~/utils/constants/beneficiary-tabs'
  import { getRandomId } from '~~/utils/random'
  import { AlertType } from '~~/utils/constants/alert'
  import { Routes } from '~/utils/routing/routes'

  definePageMeta({
    middleware: ['owns-help-request', 'is-beneficiary-referent']
  })

  const route = useRoute()
  const {
    $getItem,
    $loadOrganisationFollowUpTypes,
    $updateItem,
    $snackbar,
    $loadPrescribingOrganisations,
    $loadExaminingOrganisations
  } = useNuxtApp()

  const {
    data: helpRequest,
    pending: helpRequestPending,
    error: helpRequestError
  } = useLazyAsyncData(getRandomId('helpRequest'), loadHelpRequest, {
    server: false
  })

  const {
    data: followUpTypes,
    pending: followUpTypesPending,
    error: followUpTypesError
  } = useLazyAsyncData(
    getRandomId('followUpTypes'),
    $loadOrganisationFollowUpTypes,
    {
      server: false
    }
  )

  const {
    data: organismesPrescripteurs,
    pending: organismesPrescripteursPending,
    error: organismesPrescripteursError
  } = useLazyAsyncData(
    getRandomId('organismesPrescripteurs'),
    $loadPrescribingOrganisations,
    {
      server: false
    }
  )

  const {
    data: organismesInstructeurs,
    pending: organismesInstructeursPending,
    error: organismesInstructeursError
  } = useLazyAsyncData(
    getRandomId('organismesInstructeurs'),
    $loadExaminingOrganisations,
    {
      server: false
    }
  )

  const isSubmitting = ref(false)
  const formContainer = ref(null)

  const pending = computed(
    () =>
      helpRequestPending.value ||
      followUpTypesPending.value ||
      organismesPrescripteursPending.value ||
      organismesInstructeursPending.value
  )

  const fetchError = computed(() => {
    if (helpRequestError.value) {
      return "L'instruction de demande n'a pas pu être chargée."
    }
    if (followUpTypesError.value) {
      return "La liste des types d'accompagnement de votre structure n'a pas pu être chargée."
    }
    if (organismesPrescripteursError.value) {
      return "La liste des organismes prescripteurs de votre structure n'a pas pu être chargée."
    }
    if (organismesInstructeursError.value) {
      return "La liste des organismes instructeurs de votre structure n'a pas pu être chargée."
    }
    return ''
  })

  const title = computed(() => {
    if (!helpRequest.value) {
      return "Modifier l'instruction d'un·e bénéficiaire"
    }
    return `Modifier l'instruction de ${beneficiaryName(
      helpRequest.value.beneficiary
    )}`
  })

  const helpRequestId = computed(() => route.params.hrid)
  const beneficiaryId = computed(() => route.params.id)

  const beneficiaryPath = computed(() =>
    Routes.Beneficiary(beneficiaryId.value)
  )

  const backLink = computed(
    () =>
      `${beneficiaryPath.value}?tab=${BeneficiaryTab.History}&item=${helpRequestId.value}`
  )

  async function loadHelpRequest() {
    const fields = [
      '*',
      'private_synthesis.id',
      'private_synthesis.private_synthesis',
      'beneficiary.id',
      'beneficiary.firstname',
      'beneficiary.usual_name',
      'documents.id',
      'documents.directus_file'
    ]
    const res = await $getItem('help_requests', helpRequestId.value, {
      fields
    })

    if (res.status === 200) return res.data.data
    throw new Error(res.data.errors[0].message)
  }

  async function onUpdateHelpRequest(updatedHelpRequest) {
    isSubmitting.value = true
    try {
      const res = await $updateItem(
        'help_requests',
        helpRequest.value,
        updatedHelpRequest
      )

      if (res.status === 200) {
        return navigateTo(
          `${beneficiaryPath.value}?tab=${BeneficiaryTab.History}`
        )
      }
      throw new Error(res.data.errors[0].message)
    } catch {
      $snackbar.error("La mise à jour de l'instruction a échoué.", () =>
        formContainer.value?.querySelector('input')?.focus()
      )
    }
    isSubmitting.value = false
  }
</script>
